/*===============================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// THE PIPO WAR:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*===============================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

       
        int subCiv0=-1;
        int subCiv1=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/		
// ************************************ DEFINE THE WHICH NATIVE VARIATION: ************************************* //
/*---------------------------------------------------------------------------------------------------------------*/
	    // ONLY 2 NATIVES TRIBES ON THIS MAP:
	    int whichNative=rmRandInt(1,2);
		
/*---------------------------------------------------------------------------------------------------------------*/		
		
	       if ( whichNative == 1 )
	{
		   if (rmAllocateSubCivs(2) == true)
		{
			subCiv0=rmGetCivID("Aztecs");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Aztecs");

			subCiv1=rmGetCivID("Aztecs");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Aztecs");
		}
	}
	        else
	{
		    if (rmAllocateSubCivs(2) == true)
		{
			subCiv0=rmGetCivID("Incas");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Incas");

			subCiv1=rmGetCivID("Incas");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Incas");
		}
	} 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************* //	
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
	    int playerTiles=17500;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ***************************************** //		
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
	    // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.5);	

	    // SET SEA TYPE:
		rmSetSeaType("Amazon River Basin");
	    
		// SET BASE TERRAIN:
		rmSetBaseTerrainMix("amazon grass");
        
		// TERRAIN INITIALISE:
		rmTerrainInitialize("amazon\ground3_ama", 6);
        
		// SET LIGHTING:
		rmSetLightingSet("amazon");
			    
		// SET MAP TYPE:
		rmSetMapType("amazonia");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
		
	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();

	    // MAKE IT SNOW:
        //rmSetGlobalSnow( 0.7 );
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classMountain");
	    rmDefineClass("nuggets");

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTS:
        //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.02);
	   
		//int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.40), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
		int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.02);
        int shortPlayerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 12.0);

        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	    // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
		int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 35.0);
       
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
 
        // SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
	   		
		// TREES AVOIDANCE:
	    int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoids trees", "TreeAmazon", 15.0);
	    int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoids trees", "TreeAmazon", 5.0);
	    int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoids trees", "TreeAmazon", 25.0);
	    int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoids trees", "TreeAmazon", 45.0);
		
        
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close forest vs. forest", rmClassID("classForest"), 5.0);
        
		int northForestConstraint=rmCreateClassDistanceConstraint("n forest vs. forest", rmClassID("classForest"), 8.0);
        int southForestConstraint=rmCreateClassDistanceConstraint("s forest vs. forest", rmClassID("classForest"), 10.0);
        
		// MUSKOX AVOIDANCE:
		int avoidMuskOx=rmCreateTypeDistanceConstraint("muskOx avoids muskOx", "MuskOx", 45.0);
        
		// CARIBOU AVOIDANCE:
		int avoidCaribou=rmCreateTypeDistanceConstraint("caribou avoids caribou", "Caribou", 50.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 5.0);
        int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids deer", "deer", 25.0);
        int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoids deer", "deer", 50.0);
		
		// FOOD AVOIDANCE:
		int avoidFood=rmCreateTypeDistanceConstraint("stuff avoids food", "food", 15.0);
		int avoidCloseFood=rmCreateTypeDistanceConstraint("close avoids food", "food", 5.0);
        int avoidMediumFood=rmCreateTypeDistanceConstraint("medium avoids food", "food", 25.0);
        int avoidFarFood=rmCreateTypeDistanceConstraint("far avoids food", "food", 50.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 5.0);
        int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium avoids sheep", "sheep", 25.0);
        int avoidFarSheep=rmCreateTypeDistanceConstraint("far avoids sheep", "sheep", 50.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berries", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berries", "berrybush", 5.0);
        int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berries", "berrybush", 25.0);
        int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berries", "berrybush", 50.0);
                
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 5.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "gold", 25.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "gold", 50.0);

	    int coinAvoidsCoin=-1;
	    if (cNumberNonGaiaPlayers < 7)
	{
		coinAvoidsCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 50.0);
	}
	    else
	{
		coinAvoidsCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 40.0);
	}

        // START RESOURCE AVOIDANCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 5.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        
		// HILL AVOIDANCE:
		int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
        int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	    
		// CLIFF AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 15.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 5.0);
	    int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 25.0);
	    int avoidFarCliffs=rmCreateClassDistanceConstraint("far vs. cliff", rmClassID("classCliff"), 50.0);
	    
	    
		// MOUNTAIN AVOIDANCE:
		int mountainAvoidMountain=rmCreateClassDistanceConstraint("mountain vs. mountain", rmClassID("classMountain"), 60.0);
	    int avoidMountain=rmCreateClassDistanceConstraint("avoid mountain", rmClassID("classMountain"), 10.0);
        
		// WATER AVOIDANCE:
		int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water 4", "Land", false, 4.0);
	    int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water 12", "Land", false, 12.0);

        // UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 60.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close vs secrets", rmClassID("importantItem"), 6.0);
       	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 12.0);
        
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);
		int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
		int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
	    
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
   		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 25.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 50.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // TRADE ROUTE AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
	   
	    int avoidTradeRouteNugget = rmCreateTradeRouteDistanceConstraint("trade route nugget", 7.0);
        int avoidTradeRouteForest = rmCreateTradeRouteDistanceConstraint("trade route forest", 10.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 50.0);
		
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
   

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// ******************************************* DEFINE THE OBJECTS: ********************************************* //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ************************************ SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        if ( cNumberTeams == 2 && cNumberNonGaiaPlayers <= 4 ) 
		
		rmSetPlacementSection(0.215, 0.685);
		rmSetTeamSpacingModifier(0.45);
		
		rmPlacePlayersCircular(0.40, 0.40, rmDegreesToRadians(0.0));
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ******************************** DEFINE AND BUILD A NORTH AND A SOUTH AREAS: ******************************** //	
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND BUILD A NORTH AREA:
        int northIslandID = rmCreateArea("north island");
		int avoidNorth = rmCreateAreaDistanceConstraint("stuff avoid north", northIslandID, 15.0);  
		int northIslandConstraint = rmCreateAreaConstraint("North Island Constraint", northIslandID);
		//int northIslandConstraint = rmCreateEdgeDistanceConstraint("North Island Edge Constraint", northIslandID, 15);
		
        rmSetAreaLocation(northIslandID, 0.65, 0.15); 
        rmSetAreaWarnFailure(northIslandID, false);
	    
		rmSetAreaElevationType(northIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(northIslandID, 2.5);
        rmSetAreaBaseHeight(northIslandID, 4.5);
        
		rmSetAreaElevationMinFrequency(northIslandID, 0.07);
        rmSetAreaElevationOctaves(northIslandID, 4);
        rmSetAreaElevationPersistence(northIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(northIslandID, 1);
        rmSetAreaSize(northIslandID, 0.25, 0.25);
        rmSetAreaCoherence(northIslandID, 1.0);
		rmAddAreaInfluenceSegment(northIslandID, 0.30, 0.05, 0.95, 0.30);
        //rmAddAreaConstraint(northIslandID, NWconstraint);
        //rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
        //rmSetAreaTerrainType(northIslandID, "yukon\ground1_yuk");
		rmSetAreaMix(northIslandID, "amazon grass");
		//rmSetAreaMix(northIslandID, "texas_dirt");
	    //rmSetAreaMix(northIslandID, "yukon snow");
        rmBuildArea(northIslandID);


        //int NorthHillConstraint = rmCreateAreaConstraint("North Hill Constraint", hillNorthID);
		
/*---------------------------------------------------------------------------------------------------------------*/		
		
		int southIslandID = rmCreateArea("south island");
		int avoidSouth = rmCreateAreaDistanceConstraint("stuff avoid south", southIslandID, 15.0);
		int southIslandConstraint = rmCreateAreaConstraint("South Island Constraint", southIslandID);
		
		// DEFINE AND BUILD A SOUTH AREA:
        //int southIslandID = rmCreateArea("south island");
        rmSetAreaLocation(southIslandID, 0.4, 0.8); 
        rmSetAreaWarnFailure(southIslandID, false);
	    
		rmSetAreaElevationType(southIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(southIslandID, 2.5);
        rmSetAreaBaseHeight(southIslandID, 2.5);
        
		rmSetAreaElevationMinFrequency(southIslandID, 0.07);
        rmSetAreaElevationOctaves(southIslandID, 4);
        rmSetAreaElevationPersistence(southIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(southIslandID, 1); 
        rmSetAreaSize(southIslandID, 0.25, 0.25);
        rmSetAreaCoherence(southIslandID, 1.0);
        rmAddAreaInfluenceSegment(southIslandID, 0.1, 0.7, 0.7, 0.9);
        //rmAddAreaConstraint(southIslandID, southIslandConstraint);
        //rmSetAreaTerrainType(southIslandID, "yukon\ground6_yuk");
        //rmAddAreaTerrainLayer(southIslandID, "yukon\ground4_yuk", 0, 3);
        //rmAddAreaTerrainLayer(southIslandID, "yukon\ground5_yuk", 3, 6);
        //rmAddAreaTerrainLayer(southIslandID, "yukon\ground6_yuk", 6, 8);
        //rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
		rmSetAreaMix(southIslandID, "amazon grass");
		//rmSetAreaMix(southIslandID, "texas_dirt");
		rmBuildArea(southIslandID);
        
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// *********************** DEFINE AND PLACE A NORTH-SOUTH RIVER OR A EAST-WEST RIVER: ************************** //   
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int riverID = -1;
	        
		riverID = rmRiverCreate(-1, "Amazon River", 2, 2, 14, 14);
	
		rmRiverSetConnections(riverID, 0.025, 0.50, 0.875, 0.80);
		
		rmRiverSetShallowRadius(riverID, 12);
		
		//rmRiverAddShallow(riverID, rmRandFloat(0.1, 0.2));
		rmRiverAddShallow(riverID, rmRandFloat(0.5, 0.5));
		//rmRiverAddShallow(riverID, rmRandFloat(0.8, 0.9));
		
		rmRiverSetBankNoiseParams(riverID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
		rmRiverBuild(riverID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ******************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
        // SET AREA MIN AND MAX BLOBS:	  
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, shortPlayerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
        rmAddAreaConstraint(id, avoidImpassableLand); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTES: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    //rmAddObjectDefConstraint(socketID, avoidImpassableLand);
		rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
	    rmSetObjectDefAllowOverlap(socketID, true);
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 12.0);
				
/*---------------------------------------------------------------------------------------------------------------*/		
	
	
		// TRADE ROUTE:
		int tradeRouteID = rmCreateTradeRoute();
		
		rmAddTradeRouteWaypoint(tradeRouteID, 0.065, 0.70);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.935);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.775, 0.875, 12, 10);

		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
		if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route");

		// ADD THE SOCKETS ALONG THE TRADE ROUTE:
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
    

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// ******************* DEFINE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************* //	
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        //DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);

	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE VARIABLES FOR THE PLAYER GOLD:
		int playerGoldID=-1;
	    int silverType = -1;
	    int silverID = -1;
		
        // DEFINE THE STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeAmazon", rmRandInt(1,3), 5.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING DEER 1:
		int StartDeerID=rmCreateObjectDef("starting deer 1");
	    rmAddObjectDefItem(StartDeerID, "deer", 6, 4.0);
	    rmSetObjectDefMinDistance(StartDeerID, 12.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 12.0);
	    rmSetObjectDefCreateHerd(StartDeerID, true);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);
		
		//DEFINE THE STARTING BERRIES:
	    int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,7), 5.0);
        rmSetObjectDefMinDistance(StartBerriesID, 18);
        rmSetObjectDefMaxDistance(StartBerriesID, 18);		
	    rmAddObjectDefConstraint(StartBerriesID, avoidAll);
        rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
        rmSetObjectDefCreateHerd(StartBerriesID, true);

	    // DEFINE THE STARTING DEER 2:
		int StartDeerID2=rmCreateObjectDef("starting deer 2");
	    rmAddObjectDefItem(StartDeerID2, "deer", 4, 4.0);
	    rmSetObjectDefMinDistance(StartDeerID2, 25.0);
	    rmSetObjectDefMaxDistance(StartDeerID2, 30.0);
	    rmSetObjectDefCreateHerd(StartDeerID2, true);
	    rmAddObjectDefConstraint(StartDeerID2, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 32.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 34.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// **************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: ***************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);

		// PLACE THE PLAYER GOLD:
		// EVERYONE GETS ONE ORE GROUPING:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);			
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(playerGoldID, 16.0);
		rmSetObjectDefMaxDistance(playerGoldID, 19.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i)); 
		
		// PLACE THE STARTING DEER:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID2, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
	    int aztecVillageAID = -1;
	    int aztecVillageType = rmRandInt(1,5);
	    if ( whichNative == 1 )
		
	{
		aztecVillageAID = rmCreateGrouping("aztec village A", "native aztec village "+aztecVillageType);
	}
	    else
	{
		aztecVillageAID = rmCreateGrouping("inca village A", "native inca village "+aztecVillageType);
	}
	    rmSetGroupingMinDistance(aztecVillageAID, 0.0);
	    rmSetGroupingMaxDistance(aztecVillageAID, 0.0);
	    // rmSetGroupingMaxDistance(aztecVillageAID, rmXFractionToMeters(0.05));
	    rmAddGroupingConstraint(aztecVillageAID, avoidImpassableLand);
	    // rmAddGroupingConstraint(aztecVillageAID, playerEdgeConstraint);
	    rmAddGroupingToClass(aztecVillageAID, rmClassID("natives"));
	    rmAddGroupingToClass(aztecVillageAID, rmClassID("importantItem"));
	    rmAddGroupingConstraint(aztecVillageAID, avoidTradeRoute);
	    
		rmPlaceGroupingAtLoc(aztecVillageAID, 0, 0.725, 0.375);

/*---------------------------------------------------------------------------------------------------------------*/

	    int aztecVillageBID = -1;
	    aztecVillageType = rmRandInt(1,5);
	    if ( whichNative == 1 )
		
	{
		aztecVillageBID = rmCreateGrouping("aztec village B", "native aztec village "+aztecVillageType);
	}
	    else
	{
		aztecVillageBID = rmCreateGrouping("inca village B", "native inca village "+aztecVillageType);
	}
	    rmSetGroupingMinDistance(aztecVillageBID, 0.0);
	    rmSetGroupingMaxDistance(aztecVillageBID, 0.0);
	    // rmSetGroupingMaxDistance(aztecVillageBID, rmXFractionToMeters(0.05));
	    rmAddGroupingConstraint(aztecVillageBID, avoidImpassableLand);
	    // rmAddGroupingConstraint(aztecVillageBID, playerEdgeConstraint);
	    rmAddGroupingToClass(aztecVillageBID, rmClassID("natives"));
	    rmAddGroupingToClass(aztecVillageBID, rmClassID("importantItem"));
	    rmAddGroupingConstraint(aztecVillageBID, avoidTradeRoute);
	    
		rmPlaceGroupingAtLoc(aztecVillageBID, 0, 0.375, 0.225);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ******************************* DEFINE SOME VARIABLES THAT ARE NEEDED LATER:	******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	    
		int numTries = -1;
	    int failCount = -1;
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ******************************* LOTS OF NUGGETS IN THE NORTH - 5 PER PLAYER: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGET MIDDLE:
		rmSetNuggetDifficulty(1, 1);
	    int nuggetnorthID= rmCreateObjectDef("nugget north"); 
	    rmAddObjectDefItem(nuggetnorthID, "nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetnorthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetnorthID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetnorthID, avoidImpassableLand);
	    rmAddObjectDefToClass(nuggetnorthID, rmClassID("importantItem"));
	    rmAddObjectDefConstraint(nuggetnorthID, shortAvoidImportantItem);
	    rmAddObjectDefConstraint(nuggetnorthID, avoidNorth);
		rmAddObjectDefConstraint(nuggetnorthID, avoidSouth);
	    rmAddObjectDefConstraint(nuggetnorthID, avoidAll);
		rmAddObjectDefConstraint(nuggetnorthID, avoidCloseNatives);
		rmAddObjectDefConstraint(nuggetnorthID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(nuggetnorthID, avoidTradeRouteNugget);
	    rmAddObjectDefConstraint(nuggetnorthID, avoidFarNugget);
	    rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/

	    // 1 PER PLAYER IN THE NORTHERN HALF - LOWER DIFFICULTY:
	    rmSetNuggetDifficulty(1, 1);
	    int nuggetID= rmCreateObjectDef("nugget"); 
	    rmAddObjectDefItem(nuggetID, "nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
	    rmAddObjectDefToClass(nuggetID, rmClassID("importantItem"));
	    rmAddObjectDefConstraint(nuggetID, shortAvoidImportantItem);
	    rmAddObjectDefConstraint(nuggetID, northIslandConstraint);
	    rmAddObjectDefConstraint(nuggetID, avoidTradeRouteNugget);
	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, avoidCloseNatives);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
	    //rmAddObjectDefConstraint(nuggetID, circleConstraint);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // AND ONE BIG NUGGET SOMEWHERE IN THE SOUTHERN HALF:
	    rmSetNuggetDifficulty(1, 1);
	    int nuggetBigID= rmCreateObjectDef("nugget big"); 
	    rmAddObjectDefItem(nuggetBigID, "nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetBigID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetBigID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetBigID, avoidImpassableLand);
	    rmAddObjectDefToClass(nuggetBigID, rmClassID("importantItem"));
	    rmAddObjectDefConstraint(nuggetBigID, shortAvoidImportantItem);
	    rmAddObjectDefConstraint(nuggetBigID, southIslandConstraint);
	    rmAddObjectDefConstraint(nuggetBigID, avoidAll);
		rmAddObjectDefConstraint(nuggetBigID, avoidCloseNatives);
		rmAddObjectDefConstraint(nuggetBigID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(nuggetBigID, avoidTradeRouteNugget);
	    rmAddObjectDefConstraint(nuggetBigID, avoidFarNugget);
	    //rmAddObjectDefConstraint(nuggetBigID, circleConstraint);
	    rmPlaceObjectDefAtLoc(nuggetBigID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// **************************** DEFINE AND PLACE THE FORESTS: - NORTH AND SOUTH: ******************************* //
/*===============================================================================================================*/

	        int forestTreeID = 0;
            // THESE CONSTRAINTS KEEP FORESTS FROM MUCKING UP THE TRANSITION ZONE BETWEEN GRASS AND SNOW:
            // DAL - THINK THESE ARE BASICALLY KILLING PLACEMENT FOR MOST OF THESE THINGS:
            int forestNWconstraint = rmCreateEdgeDistanceConstraint("north forest avoid edge", northIslandID, 10);
            int forestSEconstraint = rmCreateEdgeDistanceConstraint("south forest avoid edge", southIslandID, 10);

/*---------------------------------------------------------------------------------------------------------------*/			
			
	        // FOREST NUMBER 1:
			numTries=4*cNumberNonGaiaPlayers;  
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forestID=rmCreateArea("forestID"+i);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
			rmSetAreaForestType(forestID, "amazon rain forest");
			rmSetAreaForestDensity(forestID, 1.0);
			rmSetAreaForestClumpiness(forestID, 0.8);		
			rmSetAreaForestUnderbrush(forestID, 0.0);
			rmSetAreaMinBlobs(forestID, 1);
			rmSetAreaMaxBlobs(forestID, 2);						
			rmSetAreaMinBlobDistance(forestID, 5.0);
			rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestID, southForestConstraint);  
			rmAddAreaConstraint(forestID, avoidTradeRouteForest);
			rmAddAreaConstraint(forestID, southIslandConstraint);
			rmAddAreaConstraint(forestID, forestConstraint);
			rmAddAreaConstraint(forestID, avoidMountain);
			rmAddAreaConstraint(forestID, avoidCloseNugget);
			rmAddAreaConstraint(forestID, avoidCloseNatives);
			rmAddAreaConstraint(forestID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestID, playerConstraint);
			rmAddAreaConstraint(forestID, avoidCloseImpassableLand);
			if(rmBuildArea(forestID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
		
/*---------------------------------------------------------------------------------------------------------------*/		

	        // FORESTS NUMBER 2: 
	        numTries=6*cNumberNonGaiaPlayers;  
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forest2ID=rmCreateArea("forest2ID"+i);
			rmSetAreaWarnFailure(forest2ID, false);
			rmSetAreaSize(forest2ID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
			rmSetAreaForestType(forest2ID, "amazon rain forest");
			rmSetAreaForestDensity(forest2ID, 1.0);
			rmSetAreaForestClumpiness(forest2ID, 0.8);		
			rmSetAreaForestUnderbrush(forest2ID, 0.0);
			rmSetAreaMinBlobs(forest2ID, 1);
			rmSetAreaMaxBlobs(forest2ID, 2);						
			rmSetAreaMinBlobDistance(forest2ID, 5.0);
			rmSetAreaMaxBlobDistance(forest2ID, 20.0);
			rmSetAreaCoherence(forest2ID, 0.4);
			rmSetAreaSmoothDistance(forest2ID, 10);
			rmAddAreaToClass(forest2ID, rmClassID("classForest"));
			rmAddAreaConstraint(forest2ID, northForestConstraint);
			rmAddAreaConstraint(forest2ID, avoidTradeRouteForest);
			rmAddAreaConstraint(forest2ID, northIslandConstraint);
			rmAddAreaConstraint(forest2ID, forestConstraint);
			rmAddAreaConstraint(forest2ID, avoidCloseNugget);
			rmAddAreaConstraint(forest2ID, avoidMountain);
			rmAddAreaConstraint(forest2ID, avoidCloseNatives);
			rmAddAreaConstraint(forest2ID, shortAvoidImportantItem);
			rmAddAreaConstraint(forest2ID, playerConstraint);
			rmAddAreaConstraint(forest2ID, avoidCloseImpassableLand);
			if(rmBuildArea(forest2ID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
		
/*---------------------------------------------------------------------------------------------------------------*/

            // FORESTS NUMBER 3:
	        numTries=3*cNumberNonGaiaPlayers;  
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int forest3ID=rmCreateArea("forest3ID"+i);
			rmSetAreaWarnFailure(forest3ID, false);
			rmSetAreaSize(forest3ID, rmAreaTilesToFraction(125), rmAreaTilesToFraction(175));
			rmSetAreaForestType(forest3ID, "amazon rain forest");
			rmSetAreaForestDensity(forest3ID, 1.0);
			rmSetAreaForestClumpiness(forest3ID, 0.8);		
			rmSetAreaForestUnderbrush(forest3ID, 0.0);
			rmSetAreaMinBlobs(forest3ID, 1);
			rmSetAreaMaxBlobs(forest3ID, 2);						
			rmSetAreaMinBlobDistance(forest3ID, 5.0);
			rmSetAreaMaxBlobDistance(forest3ID, 20.0);
			rmSetAreaCoherence(forest3ID, 0.4);
			rmSetAreaSmoothDistance(forest3ID, 10);
			rmAddAreaToClass(forest3ID, rmClassID("classForest"));
			rmAddAreaConstraint(forest3ID, avoidNorth);
			rmAddAreaConstraint(forest3ID, avoidSouth);
			rmAddAreaConstraint(forest3ID, avoidCloseNugget);
			rmAddAreaConstraint(forest3ID, avoidTradeRouteForest);
			rmAddAreaConstraint(forest3ID, forestConstraint);
			rmAddAreaConstraint(forest3ID, avoidMountain);
			rmAddAreaConstraint(forest3ID, avoidCloseNatives);
			rmAddAreaConstraint(forest3ID, shortAvoidImportantItem);
			rmAddAreaConstraint(forest3ID, playerConstraint);
			rmAddAreaConstraint(forest3ID, avoidCloseImpassableLand);
			if(rmBuildArea(forest3ID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 		
			
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// ******************************* DEFINE AND PLACE THE GOLD AND SILVER MINRS: ********************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        	
	    int silverCount1 = cNumberNonGaiaPlayers;
	    int silverCount2 = cNumberNonGaiaPlayers*2;
	    rmEchoInfo("silver count 1 = "+silverCount1);
	    rmEchoInfo("silver count 2 = "+silverCount2);

/*---------------------------------------------------------------------------------------------------------------*/
		
	    // TWO PER PLAYER IN THE MIDDLE - AND THESE ARE GOLD:
	    for(i=0; < silverCount2)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("middle silver "+i);
		rmAddObjectDefItem(silverID, "mineGold", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, coinAvoidsCoin);
		rmAddObjectDefConstraint(silverID, coinEdgeConstraint);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRouteForest);
		rmAddObjectDefConstraint(silverID, shortAvoidImportantItem);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, playerConstraint);
		rmAddObjectDefConstraint(silverID, avoidWater12);
		rmAddObjectDefConstraint(silverID, avoidNorth);
		rmAddObjectDefConstraint(silverID, avoidSouth);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
   
  /*-------------------------------------------------------------------------------------------------------------*/ 

	    // ONE PER PLAYER IN THE "NORTH":
	    for(i=0; < silverCount1)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("north silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, coinAvoidsCoin);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, shortAvoidImportantItem);
		rmAddObjectDefConstraint(silverID, playerConstraint);
		rmAddObjectDefConstraint(silverID, northIslandConstraint);
		rmAddObjectDefConstraint(silverID, avoidWater12);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
   
/*---------------------------------------------------------------------------------------------------------------*/   

	    // ONE PER PLAYER IN THE "SOUTH":
	    for(i=0; < silverCount1)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("south silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, coinAvoidsCoin);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, shortAvoidImportantItem);
		rmAddObjectDefConstraint(silverID, playerConstraint);
		rmAddObjectDefConstraint(silverID, southIslandConstraint);
		rmAddObjectDefConstraint(silverID, avoidWater12);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.94);
/*===============================================================================================================*/
// ******************************** RESOURCES THAT CAN BE PLACED AFTER FORESTS: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE DEER HERD 1:
		int Deer1ID=rmCreateObjectDef("Deer Herd 1");
	    rmAddObjectDefItem(Deer1ID, "deer", rmRandInt(8,10), 8.0);
	    rmSetObjectDefMinDistance(Deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(Deer1ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Deer1ID, avoidFarDeer);
	    rmAddObjectDefConstraint(Deer1ID, avoidAll);
		 rmAddObjectDefConstraint(Deer1ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Deer1ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Deer1ID, northIslandConstraint);
	    rmAddObjectDefConstraint(Deer1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Deer1ID, avoidMountain);
	    rmAddObjectDefConstraint(Deer1ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Deer1ID, true);
		
		// PLACE THE DEER HERD 1:
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE DEER HERD 2:
		int Deer2ID=rmCreateObjectDef("Deer Herd 2");
	    rmAddObjectDefItem(Deer2ID, "deer", rmRandInt(8,10), 8.0);
	    rmSetObjectDefMinDistance(Deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(Deer2ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Deer2ID, avoidFarDeer);
	    rmAddObjectDefConstraint(Deer2ID, avoidAll);
		rmAddObjectDefConstraint(Deer2ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Deer2ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Deer2ID, southIslandConstraint);
	    rmAddObjectDefConstraint(Deer2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Deer2ID, avoidMountain);
	    rmAddObjectDefConstraint(Deer2ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Deer2ID, true);
		
		// PLACE THE DEER HERD 1:
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRIES: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		// DEFINE THE BERRIES 1:
		int Berries1ID=rmCreateObjectDef("The Berries 1");
	    rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Berries1ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries1ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Berries1ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Berries1ID, avoidAll);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseDeer);
		rmAddObjectDefConstraint(Berries1ID, avoidSouth);
		rmAddObjectDefConstraint(Berries1ID, avoidNorth);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Berries1ID, avoidCloseCoin);
	    rmAddObjectDefConstraint(Berries1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries1ID, avoidMountain);
	    rmAddObjectDefConstraint(Berries1ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Berries1ID, true);
		
		// PLACE THE BERRIES 1:
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE BERRIES 2:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
	    rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(Berries2ID, southIslandConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
	    rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries2ID, avoidMountain);
	    rmAddObjectDefConstraint(Berries2ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Berries2ID, true);
		
		// PLACE THE BERRIES 2:
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE BERRIES 3:
		int Berries3ID=rmCreateObjectDef("The Berries 3");
	    rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Berries3ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Berries3ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Berries3ID, avoidAll);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseDeer);
		rmAddObjectDefConstraint(Berries3ID, northIslandConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Berries3ID, avoidCloseCoin);
	    rmAddObjectDefConstraint(Berries3ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries3ID, avoidMountain);
	    rmAddObjectDefConstraint(Berries3ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Berries3ID, true);
		
		// PLACE THE BERRIES 3:
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		// DEFINE THE SHEEPS 1:
		int Sheep1ID=rmCreateObjectDef("The Sheeps 1");
	    rmAddObjectDefItem(Sheep1ID, "sheep", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(Sheep1ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Sheep1ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Sheep1ID, avoidAll);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Sheep1ID, avoidFarDeer);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Sheep1ID, avoidFarSheep);
		rmAddObjectDefConstraint(Sheep1ID, avoidSouth);
		rmAddObjectDefConstraint(Sheep1ID, avoidNorth);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Sheep1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Sheep1ID, avoidMountain);
	    rmAddObjectDefConstraint(Sheep1ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Sheep1ID, true);
		
		// PLACE THE SHEEP HERD 1:
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
        // DEFINE THE SHEEPS 2:
		int Sheep2ID=rmCreateObjectDef("The Sheeps 2");
	    rmAddObjectDefItem(Sheep2ID, "sheep", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(Sheep2ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Sheep2ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Sheep2ID, avoidAll);
		rmAddObjectDefConstraint(Sheep2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Sheep2ID, avoidFarDeer);
		rmAddObjectDefConstraint(Sheep2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Sheep2ID, avoidFarSheep);
		rmAddObjectDefConstraint(Sheep2ID, northIslandConstraint);
		rmAddObjectDefConstraint(Sheep2ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Sheep2ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Sheep2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Sheep2ID, avoidMountain);
	    rmAddObjectDefConstraint(Sheep2ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Sheep2ID, true);
		
		// PLACE THE SHEEP HERD 2:
		rmPlaceObjectDefAtLoc(Sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE SHEEPS 3:
		int Sheep3ID=rmCreateObjectDef("The Sheeps 3");
	    rmAddObjectDefItem(Sheep3ID, "sheep", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(Sheep3ID, 0.0);
	    rmSetObjectDefMaxDistance(Sheep3ID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(Sheep3ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Sheep3ID, avoidAll);
		rmAddObjectDefConstraint(Sheep3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Sheep3ID, avoidMediumDeer);
		rmAddObjectDefConstraint(Sheep3ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Sheep3ID, avoidFarSheep);
		rmAddObjectDefConstraint(Sheep3ID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(Sheep3ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(Sheep3ID, southIslandConstraint);
	    rmAddObjectDefConstraint(Sheep3ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Sheep3ID, avoidMountain);
	    rmAddObjectDefConstraint(Sheep3ID, playerConstraint);
	    rmSetObjectDefCreateHerd(Sheep3ID, true);
		
		// PLACE THE SHEEP HERD 3:
		rmPlaceObjectDefAtLoc(Sheep3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.97);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int randomTreeID=rmCreateObjectDef("random tree 1");
        rmAddObjectDefItem(randomTreeID, "TreeAmazon", rmRandInt(2,5), 6.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerMediumConstraint);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);   
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidNorth);
		rmAddObjectDefConstraint(randomTreeID, avoidSouth);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
	    		
        rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);	

/*---------------------------------------------------------------------------------------------------------------*/

        int randomTree2ID=rmCreateObjectDef("random tree 2");
        rmAddObjectDefItem(randomTree2ID, "TreeAmazon", rmRandInt(1,3), 5.0);
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, playerMediumConstraint);
	    rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);   
	    rmAddObjectDefConstraint(randomTree2ID, southIslandConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTree2ID, avoidImpassableLand);
	    		
        rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

/*---------------------------------------------------------------------------------------------------------------*/

        int randomTree3ID=rmCreateObjectDef("random tree 3");
        rmAddObjectDefItem(randomTree3ID, "TreeAmazon", rmRandInt(1,3), 5.0);
		rmSetObjectDefMinDistance(randomTree3ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree3ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree3ID, playerMediumConstraint);
	    rmAddObjectDefConstraint(randomTree3ID, forestCloseConstraint);   
	    rmAddObjectDefConstraint(randomTree3ID, northIslandConstraint);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTree3ID, avoidAll);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree3ID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTree3ID, avoidImpassableLand);
	    		
        rmPlaceObjectDefAtLoc(randomTree3ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.98);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE SMALL RANDOM MESA: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int canyon=rmDefineClass("canyon");
        int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 15.0);
	    int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 5.0);
		int avoidMediumCanyons=rmCreateClassDistanceConstraint("medium avoid canyons", rmClassID("canyon"), 25.0);
	    int avoidFarCanyons=rmCreateClassDistanceConstraint("far avoid canyons", rmClassID("canyon"), 50.0);
		
/*---------------------------------------------------------------------------------------------------------------*/		
	        
		numTries = 5*cNumberNonGaiaPlayers;
   
        for(i=0; <numTries)
   {
		
        int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Amazon");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesaID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesaID, avoidCanyons);
		rmSetAreaMinBlobs(smallMesaID, 1);
		rmSetAreaMaxBlobs(smallMesaID, 1);
		rmSetAreaMinBlobDistance(smallMesaID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesaID, 1.0);
		rmSetAreaCoherence(smallMesaID, 1.0);
		rmAddAreaConstraint(smallMesaID, playerConstraint); 
		rmAddAreaConstraint(smallMesaID, forestCloseConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidCloseDeer);
        rmAddAreaConstraint(smallMesaID, avoidCloseSheep); 			
		rmAddAreaConstraint(smallMesaID, avoidCloseTrees); 
		rmAddAreaConstraint(smallMesaID, avoidFarCliffs); 
		rmAddAreaConstraint(smallMesaID, avoidCloseNugget); 
		rmAddAreaConstraint(smallMesaID, avoidCloseFruits);
        rmAddAreaConstraint(smallMesaID, avoidImpassableLand); 		
		rmAddAreaConstraint(smallMesaID, northIslandConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidCloseImportantItem);
		rmAddAreaConstraint(smallMesaID, avoidCloseNatives);
		rmAddAreaConstraint(smallMesaID, avoidCloseTradeRoute);
		rmAddAreaConstraint(smallMesaID, avoidCloseCoin);
		rmBuildArea(smallMesaID);
	}
	
/*---------------------------------------------------------------------------------------------------------------*/
        	        
		numTries = 5*cNumberNonGaiaPlayers;
   
        for(i=0; <numTries)
   {
		
        int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "Amazon");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesa2ID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesa2ID, avoidCanyons);
		rmSetAreaMinBlobs(smallMesa2ID, 1);
		rmSetAreaMaxBlobs(smallMesa2ID, 1);
		rmSetAreaMinBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa2ID, 1.0);
		rmSetAreaCoherence(smallMesa2ID, 1.0);
		rmAddAreaConstraint(smallMesa2ID, playerConstraint);
		rmAddAreaConstraint(smallMesa2ID, forestCloseConstraint); 
        rmAddAreaConstraint(smallMesa2ID, avoidCloseDeer);
        rmAddAreaConstraint(smallMesa2ID, avoidCloseSheep); 	 		
		rmAddAreaConstraint(smallMesa2ID, avoidCloseTrees); 
		rmAddAreaConstraint(smallMesa2ID, avoidFarCliffs); 
		rmAddAreaConstraint(smallMesa2ID, avoidCloseNugget); 
		rmAddAreaConstraint(smallMesa2ID, avoidCloseFruits);
        rmAddAreaConstraint(smallMesa2ID, avoidImpassableLand); 		
		rmAddAreaConstraint(smallMesa2ID, southIslandConstraint); 
		rmAddAreaConstraint(smallMesa2ID, avoidCloseImportantItem);
		rmAddAreaConstraint(smallMesa2ID, avoidCloseNatives);
		rmAddAreaConstraint(smallMesa2ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(smallMesa2ID, avoidCloseCoin);
		rmBuildArea(smallMesa2ID);
	}	
	
/*---------------------------------------------------------------------------------------------------------------*/

        numTries = 5*cNumberNonGaiaPlayers;
   
        for(i=0; <numTries)
   {
		
        int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));  
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Amazon");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesa3ID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesa3ID, avoidCanyons);
		rmSetAreaMinBlobs(smallMesa3ID, 1);
		rmSetAreaMaxBlobs(smallMesa3ID, 1);
		rmSetAreaMinBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa3ID, 1.0);
		rmSetAreaCoherence(smallMesa3ID, 1.0);
		rmAddAreaConstraint(smallMesa3ID, playerConstraint);
		rmAddAreaConstraint(smallMesa3ID, forestCloseConstraint); 
        rmAddAreaConstraint(smallMesa3ID, avoidCloseDeer); 
        rmAddAreaConstraint(smallMesa3ID, avoidCloseSheep); 			
		rmAddAreaConstraint(smallMesa3ID, avoidCloseTrees); 
		rmAddAreaConstraint(smallMesa3ID, avoidFarCliffs); 
		rmAddAreaConstraint(smallMesa3ID, avoidCloseNugget); 
		rmAddAreaConstraint(smallMesa3ID, avoidCloseFruits);
        rmAddAreaConstraint(smallMesa3ID, avoidImpassableLand); 		
		rmAddAreaConstraint(smallMesa3ID, avoidSouth);
        rmAddAreaConstraint(smallMesa3ID, avoidNorth); 		
		rmAddAreaConstraint(smallMesa3ID, avoidCloseImportantItem);
		rmAddAreaConstraint(smallMesa3ID, avoidCloseNatives);
		rmAddAreaConstraint(smallMesa3ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(smallMesa3ID, avoidCloseCoin);
		rmBuildArea(smallMesa3ID);
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishMahi", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
